/*****************************************************************************
**
**  atributers.c
**
**  Description:
**     Contains Unigraphics entry points for the application.
**
*****************************************************************************/
#include <stdio.h> 
#include <stdlib.h>
#include <string.h>

#include <uf_exit.h>
#include <uf_styler.h>

#include <uf_mb.h>
#include <uf.h> 
#include <uf_ui.h>
#include <uf_defs.h>
#include <uf_attr.h> 
#include <uf_part.h> 
#include <uf_modl.h> 
#include <uf_assem.h> 
#include <uf_object_types.h> 

#include "main_atr.h"
#include "variables.h"

#define PRTERR(line)if(errorCode){PrintErrorMessage(errorCode, line);errorCode=0;goto term;}
int ATR ( int *respons );
int VVOD ( int *ponse );
extern int VVOD_error;
extern int ATR_error;

/**************************************************************************************/
/**************************************************************************************/
/**************************************************************************************/
extern DllExport void ufusr( char *parm, int *returnCode, int rlen )
{	/*
		  
			OK								-	2
			APPLAY    	-	9
			CANCEL							-	3
			button_ATR	-	>0,      ;	

		  
			OK			-	2
			APPLAY		-	9
			CANCEL		-	3

		   :
			OK			-	 ,    .
			APPLAY		-	 ,    .
			CANCEL		-	  ,    .

	
	   :
			OK			-	  .
			APPLAY		-	  .
			CANCEL		-	  .

		 ,   /     *.prt.
	

		  button_ATR  ,  STYLER 
	"push button"   .     ITEM  "push button".
		      iman_tit[] ug_tit[].
		  
			
	*/
	
	int resp;
	int ttt;
	

    prterr=fopen("C:\\prterr.txt","w");
	fprintf(prterr,"atributers has STARTED line=%d\n",__LINE__);
	
    UF_initialize();	PRTERR(__LINE__);
	button_ATR=-1;


	disp_part=UF_PART_ask_display_part ( );
	/*fprintf(prterr,"	from  main	 disp_part=%d	\n", disp_part);*/

	resp=9;
	while(resp==9)
	{
		resp=0;
		ATR_error=0;
		button_ATR=-1;
		ATR(&resp);	  	
		if(ATR_error) goto term;
		//fprintf(prterr,"from UFUSR  from WHILE  after ATR  resp=%d\n",  resp);
		if( resp==9 && button_ATR>=0 )
			{
				ttt=0;
				VVOD_error=0;
				VVOD(&ttt);
				if(VVOD_error)	goto term;
				/*fprintf(prterr,"from UFUSR  from WHILE  after VVOD  ttt=%d  \n", ttt);*/
			}

	}
	/*fprintf(prterr,"from UFUSR  after WHILE resp=%d\n",  resp);*/


term:        
        errorCode = UF_terminate();
		if(errorCode)
		    PrintErrorMessage( errorCode, __LINE__ );
		fprintf(prterr,"atributers has STOPED line=%d\n",__LINE__);
		fflush(prterr);
		fclose(prterr);
}

/**************************************************************************************/
/**************************************************************************************/
/**************************************************************************************/
extern int ufusr_ask_unload( void )
{
   return( UF_UNLOAD_IMMEDIATELY );
}


/**************************************************************************************/
/**************************************************************************************/
/**************************************************************************************/
static void PrintErrorMessage( int errorCode, int line)
{
    if ( 0 != errorCode )
    {
        /* Retrieve the associated error message */
        char message[133];
        UF_get_fail_message( errorCode, message );

        /* Print out the message */
        UF_UI_set_status( message );

        fprintf( prterr, "%s   line=%d\n", message, line );
    }
}
